package com.hammurapi.review;

import com.hammurapi.review.Module;
import com.hammurapi.review.Observation;

public class ModuleAggregator extends Aggregator {

	private Module module;
	private Summary summary;

	public ModuleAggregator(Module module, Summary summary) {
		this.module = module;
		this.summary = summary;
	}
	
	@Override
	public void consumeObservation(Observation observation)	throws ReviewException {
		super.consumeObservation(observation);
		summary.consumeObservation(observation);
	}
	
	public Module getModule() {
		return module;
	}

}
