/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package com.hammurapi.review.impl;

import com.hammurapi.party.PartyPackage;
import com.hammurapi.party.Role;
import com.hammurapi.review.Inspector;
import java.util.Collection;
import java.util.concurrent.atomic.AtomicInteger;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.EObjectImpl;
import org.eclipse.emf.ecore.util.EDataTypeUniqueEList;
import org.eclipse.emf.ecore.util.EObjectContainmentWithInverseEList;
import org.eclipse.emf.ecore.util.EObjectWithInverseResolvingEList;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.util.InternalEList;

import com.hammurapi.review.InspectorCategory;
import com.hammurapi.review.ReviewPackage;
import com.hammurapi.review.ToolVersion;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Inspector Category</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link com.hammurapi.review.impl.InspectorCategoryImpl#getRoles <em>Roles</em>}</li>
 *   <li>{@link com.hammurapi.review.impl.InspectorCategoryImpl#getUid <em>Uid</em>}</li>
 *   <li>{@link com.hammurapi.review.impl.InspectorCategoryImpl#getName <em>Name</em>}</li>
 *   <li>{@link com.hammurapi.review.impl.InspectorCategoryImpl#getDescription <em>Description</em>}</li>
 *   <li>{@link com.hammurapi.review.impl.InspectorCategoryImpl#getReferences <em>References</em>}</li>
 *   <li>{@link com.hammurapi.review.impl.InspectorCategoryImpl#getHomePage <em>Home Page</em>}</li>
 *   <li>{@link com.hammurapi.review.impl.InspectorCategoryImpl#getSubCategory <em>Sub Category</em>}</li>
 *   <li>{@link com.hammurapi.review.impl.InspectorCategoryImpl#getParentCategory <em>Parent Category</em>}</li>
 *   <li>{@link com.hammurapi.review.impl.InspectorCategoryImpl#getExternalParent <em>External Parent</em>}</li>
 *   <li>{@link com.hammurapi.review.impl.InspectorCategoryImpl#getGovernedBy <em>Governed By</em>}</li>
 *   <li>{@link com.hammurapi.review.impl.InspectorCategoryImpl#getInspectors <em>Inspectors</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class InspectorCategoryImpl extends EObjectImpl implements InspectorCategory {
	/**
	 * The cached value of the '{@link #getRoles() <em>Roles</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getRoles()
	 * @generated
	 * @ordered
	 */
	protected EList<Role> roles;

	/**
	 * The default value of the '{@link #getUid() <em>Uid</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getUid()
	 * @generated
	 * @ordered
	 */
	protected static final String UID_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getUid() <em>Uid</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getUid()
	 * @generated
	 * @ordered
	 */
	protected String uid = UID_EDEFAULT;

	/**
	 * The default value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected static final String NAME_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected String name = NAME_EDEFAULT;

	/**
	 * The default value of the '{@link #getDescription() <em>Description</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDescription()
	 * @generated
	 * @ordered
	 */
	protected static final String DESCRIPTION_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getDescription() <em>Description</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDescription()
	 * @generated
	 * @ordered
	 */
	protected String description = DESCRIPTION_EDEFAULT;

	/**
	 * The cached value of the '{@link #getReferences() <em>References</em>}' attribute list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getReferences()
	 * @generated
	 * @ordered
	 */
	protected EList<String> references;

	/**
	 * The default value of the '{@link #getHomePage() <em>Home Page</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getHomePage()
	 * @generated
	 * @ordered
	 */
	protected static final String HOME_PAGE_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getHomePage() <em>Home Page</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getHomePage()
	 * @generated
	 * @ordered
	 */
	protected String homePage = HOME_PAGE_EDEFAULT;

	/**
	 * The cached value of the '{@link #getSubCategory() <em>Sub Category</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getSubCategory()
	 * @generated
	 * @ordered
	 */
	protected EList<InspectorCategory> subCategory;

	/**
	 * The cached value of the '{@link #getExternalParent() <em>External Parent</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getExternalParent()
	 * @generated
	 * @ordered
	 */
	protected InspectorCategory externalParent;

	/**
	 * The cached value of the '{@link #getGovernedBy() <em>Governed By</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getGovernedBy()
	 * @generated
	 * @ordered
	 */
	protected EList<ToolVersion> governedBy;

	/**
	 * The cached value of the '{@link #getInspectors() <em>Inspectors</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getInspectors()
	 * @generated
	 * @ordered
	 */
	protected EList<Inspector> inspectors;

	private static AtomicInteger counter = new AtomicInteger();
	
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	protected InspectorCategoryImpl() {
		super();
		if (getUid()==null) {
			setUid("CAT-"+Integer.toString(counter.incrementAndGet(), Character.MAX_RADIX)+"-"+Long.toString(System.currentTimeMillis(), Character.MAX_RADIX));
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return ReviewPackage.Literals.INSPECTOR_CATEGORY;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Role> getRoles() {
		if (roles == null) {
			roles = new EObjectContainmentWithInverseEList<Role>(Role.class, this, ReviewPackage.INSPECTOR_CATEGORY__ROLES, PartyPackage.ROLE__OWNER);
		}
		return roles;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getUid() {
		return uid;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setUid(String newUid) {
		String oldUid = uid;
		uid = newUid;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ReviewPackage.INSPECTOR_CATEGORY__UID, oldUid, uid));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getName() {
		return name;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setName(String newName) {
		String oldName = name;
		name = newName;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ReviewPackage.INSPECTOR_CATEGORY__NAME, oldName, name));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getDescription() {
		return description;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setDescription(String newDescription) {
		String oldDescription = description;
		description = newDescription;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ReviewPackage.INSPECTOR_CATEGORY__DESCRIPTION, oldDescription, description));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<String> getReferences() {
		if (references == null) {
			references = new EDataTypeUniqueEList<String>(String.class, this, ReviewPackage.INSPECTOR_CATEGORY__REFERENCES);
		}
		return references;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getHomePage() {
		return homePage;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setHomePage(String newHomePage) {
		String oldHomePage = homePage;
		homePage = newHomePage;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ReviewPackage.INSPECTOR_CATEGORY__HOME_PAGE, oldHomePage, homePage));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<InspectorCategory> getSubCategory() {
		if (subCategory == null) {
			subCategory = new EObjectContainmentWithInverseEList<InspectorCategory>(InspectorCategory.class, this, ReviewPackage.INSPECTOR_CATEGORY__SUB_CATEGORY, ReviewPackage.INSPECTOR_CATEGORY__PARENT_CATEGORY);
		}
		return subCategory;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public InspectorCategory getParentCategory() {
		if (eContainerFeatureID() != ReviewPackage.INSPECTOR_CATEGORY__PARENT_CATEGORY) return null;
		return (InspectorCategory)eContainer();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetParentCategory(InspectorCategory newParentCategory, NotificationChain msgs) {
		msgs = eBasicSetContainer((InternalEObject)newParentCategory, ReviewPackage.INSPECTOR_CATEGORY__PARENT_CATEGORY, msgs);
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setParentCategory(InspectorCategory newParentCategory) {
		if (newParentCategory != eInternalContainer() || (eContainerFeatureID() != ReviewPackage.INSPECTOR_CATEGORY__PARENT_CATEGORY && newParentCategory != null)) {
			if (EcoreUtil.isAncestor(this, newParentCategory))
				throw new IllegalArgumentException("Recursive containment not allowed for " + toString());
			NotificationChain msgs = null;
			if (eInternalContainer() != null)
				msgs = eBasicRemoveFromContainer(msgs);
			if (newParentCategory != null)
				msgs = ((InternalEObject)newParentCategory).eInverseAdd(this, ReviewPackage.INSPECTOR_CATEGORY__SUB_CATEGORY, InspectorCategory.class, msgs);
			msgs = basicSetParentCategory(newParentCategory, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ReviewPackage.INSPECTOR_CATEGORY__PARENT_CATEGORY, newParentCategory, newParentCategory));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public InspectorCategory getExternalParent() {
		if (externalParent != null && externalParent.eIsProxy()) {
			InternalEObject oldExternalParent = (InternalEObject)externalParent;
			externalParent = (InspectorCategory)eResolveProxy(oldExternalParent);
			if (externalParent != oldExternalParent) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, ReviewPackage.INSPECTOR_CATEGORY__EXTERNAL_PARENT, oldExternalParent, externalParent));
			}
		}
		return externalParent;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public InspectorCategory basicGetExternalParent() {
		return externalParent;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setExternalParent(InspectorCategory newExternalParent) {
		InspectorCategory oldExternalParent = externalParent;
		externalParent = newExternalParent;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ReviewPackage.INSPECTOR_CATEGORY__EXTERNAL_PARENT, oldExternalParent, externalParent));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<ToolVersion> getGovernedBy() {
		if (governedBy == null) {
			governedBy = new EObjectWithInverseResolvingEList.ManyInverse<ToolVersion>(ToolVersion.class, this, ReviewPackage.INSPECTOR_CATEGORY__GOVERNED_BY, ReviewPackage.TOOL_VERSION__GOVERNS);
		}
		return governedBy;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Inspector> getInspectors() {
		if (inspectors == null) {
			inspectors = new EObjectWithInverseResolvingEList<Inspector>(Inspector.class, this, ReviewPackage.INSPECTOR_CATEGORY__INSPECTORS, ReviewPackage.INSPECTOR__CATEGORY);
		}
		return inspectors;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public String getPath() {
		if (getParentCategory()==null) {
			if (getExternalParent()==null) {
				return getName();
			}
			return getExternalParent().getPath()+"/"+getName();
		}
		return getParentCategory().getPath()+"/"+getName();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case ReviewPackage.INSPECTOR_CATEGORY__ROLES:
				return ((InternalEList<InternalEObject>)(InternalEList<?>)getRoles()).basicAdd(otherEnd, msgs);
			case ReviewPackage.INSPECTOR_CATEGORY__SUB_CATEGORY:
				return ((InternalEList<InternalEObject>)(InternalEList<?>)getSubCategory()).basicAdd(otherEnd, msgs);
			case ReviewPackage.INSPECTOR_CATEGORY__PARENT_CATEGORY:
				if (eInternalContainer() != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return basicSetParentCategory((InspectorCategory)otherEnd, msgs);
			case ReviewPackage.INSPECTOR_CATEGORY__GOVERNED_BY:
				return ((InternalEList<InternalEObject>)(InternalEList<?>)getGovernedBy()).basicAdd(otherEnd, msgs);
			case ReviewPackage.INSPECTOR_CATEGORY__INSPECTORS:
				return ((InternalEList<InternalEObject>)(InternalEList<?>)getInspectors()).basicAdd(otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case ReviewPackage.INSPECTOR_CATEGORY__ROLES:
				return ((InternalEList<?>)getRoles()).basicRemove(otherEnd, msgs);
			case ReviewPackage.INSPECTOR_CATEGORY__SUB_CATEGORY:
				return ((InternalEList<?>)getSubCategory()).basicRemove(otherEnd, msgs);
			case ReviewPackage.INSPECTOR_CATEGORY__PARENT_CATEGORY:
				return basicSetParentCategory(null, msgs);
			case ReviewPackage.INSPECTOR_CATEGORY__GOVERNED_BY:
				return ((InternalEList<?>)getGovernedBy()).basicRemove(otherEnd, msgs);
			case ReviewPackage.INSPECTOR_CATEGORY__INSPECTORS:
				return ((InternalEList<?>)getInspectors()).basicRemove(otherEnd, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eBasicRemoveFromContainerFeature(NotificationChain msgs) {
		switch (eContainerFeatureID()) {
			case ReviewPackage.INSPECTOR_CATEGORY__PARENT_CATEGORY:
				return eInternalContainer().eInverseRemove(this, ReviewPackage.INSPECTOR_CATEGORY__SUB_CATEGORY, InspectorCategory.class, msgs);
		}
		return super.eBasicRemoveFromContainerFeature(msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case ReviewPackage.INSPECTOR_CATEGORY__ROLES:
				return getRoles();
			case ReviewPackage.INSPECTOR_CATEGORY__UID:
				return getUid();
			case ReviewPackage.INSPECTOR_CATEGORY__NAME:
				return getName();
			case ReviewPackage.INSPECTOR_CATEGORY__DESCRIPTION:
				return getDescription();
			case ReviewPackage.INSPECTOR_CATEGORY__REFERENCES:
				return getReferences();
			case ReviewPackage.INSPECTOR_CATEGORY__HOME_PAGE:
				return getHomePage();
			case ReviewPackage.INSPECTOR_CATEGORY__SUB_CATEGORY:
				return getSubCategory();
			case ReviewPackage.INSPECTOR_CATEGORY__PARENT_CATEGORY:
				return getParentCategory();
			case ReviewPackage.INSPECTOR_CATEGORY__EXTERNAL_PARENT:
				if (resolve) return getExternalParent();
				return basicGetExternalParent();
			case ReviewPackage.INSPECTOR_CATEGORY__GOVERNED_BY:
				return getGovernedBy();
			case ReviewPackage.INSPECTOR_CATEGORY__INSPECTORS:
				return getInspectors();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case ReviewPackage.INSPECTOR_CATEGORY__ROLES:
				getRoles().clear();
				getRoles().addAll((Collection<? extends Role>)newValue);
				return;
			case ReviewPackage.INSPECTOR_CATEGORY__UID:
				setUid((String)newValue);
				return;
			case ReviewPackage.INSPECTOR_CATEGORY__NAME:
				setName((String)newValue);
				return;
			case ReviewPackage.INSPECTOR_CATEGORY__DESCRIPTION:
				setDescription((String)newValue);
				return;
			case ReviewPackage.INSPECTOR_CATEGORY__REFERENCES:
				getReferences().clear();
				getReferences().addAll((Collection<? extends String>)newValue);
				return;
			case ReviewPackage.INSPECTOR_CATEGORY__HOME_PAGE:
				setHomePage((String)newValue);
				return;
			case ReviewPackage.INSPECTOR_CATEGORY__SUB_CATEGORY:
				getSubCategory().clear();
				getSubCategory().addAll((Collection<? extends InspectorCategory>)newValue);
				return;
			case ReviewPackage.INSPECTOR_CATEGORY__PARENT_CATEGORY:
				setParentCategory((InspectorCategory)newValue);
				return;
			case ReviewPackage.INSPECTOR_CATEGORY__EXTERNAL_PARENT:
				setExternalParent((InspectorCategory)newValue);
				return;
			case ReviewPackage.INSPECTOR_CATEGORY__GOVERNED_BY:
				getGovernedBy().clear();
				getGovernedBy().addAll((Collection<? extends ToolVersion>)newValue);
				return;
			case ReviewPackage.INSPECTOR_CATEGORY__INSPECTORS:
				getInspectors().clear();
				getInspectors().addAll((Collection<? extends Inspector>)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case ReviewPackage.INSPECTOR_CATEGORY__ROLES:
				getRoles().clear();
				return;
			case ReviewPackage.INSPECTOR_CATEGORY__UID:
				setUid(UID_EDEFAULT);
				return;
			case ReviewPackage.INSPECTOR_CATEGORY__NAME:
				setName(NAME_EDEFAULT);
				return;
			case ReviewPackage.INSPECTOR_CATEGORY__DESCRIPTION:
				setDescription(DESCRIPTION_EDEFAULT);
				return;
			case ReviewPackage.INSPECTOR_CATEGORY__REFERENCES:
				getReferences().clear();
				return;
			case ReviewPackage.INSPECTOR_CATEGORY__HOME_PAGE:
				setHomePage(HOME_PAGE_EDEFAULT);
				return;
			case ReviewPackage.INSPECTOR_CATEGORY__SUB_CATEGORY:
				getSubCategory().clear();
				return;
			case ReviewPackage.INSPECTOR_CATEGORY__PARENT_CATEGORY:
				setParentCategory((InspectorCategory)null);
				return;
			case ReviewPackage.INSPECTOR_CATEGORY__EXTERNAL_PARENT:
				setExternalParent((InspectorCategory)null);
				return;
			case ReviewPackage.INSPECTOR_CATEGORY__GOVERNED_BY:
				getGovernedBy().clear();
				return;
			case ReviewPackage.INSPECTOR_CATEGORY__INSPECTORS:
				getInspectors().clear();
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case ReviewPackage.INSPECTOR_CATEGORY__ROLES:
				return roles != null && !roles.isEmpty();
			case ReviewPackage.INSPECTOR_CATEGORY__UID:
				return UID_EDEFAULT == null ? uid != null : !UID_EDEFAULT.equals(uid);
			case ReviewPackage.INSPECTOR_CATEGORY__NAME:
				return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
			case ReviewPackage.INSPECTOR_CATEGORY__DESCRIPTION:
				return DESCRIPTION_EDEFAULT == null ? description != null : !DESCRIPTION_EDEFAULT.equals(description);
			case ReviewPackage.INSPECTOR_CATEGORY__REFERENCES:
				return references != null && !references.isEmpty();
			case ReviewPackage.INSPECTOR_CATEGORY__HOME_PAGE:
				return HOME_PAGE_EDEFAULT == null ? homePage != null : !HOME_PAGE_EDEFAULT.equals(homePage);
			case ReviewPackage.INSPECTOR_CATEGORY__SUB_CATEGORY:
				return subCategory != null && !subCategory.isEmpty();
			case ReviewPackage.INSPECTOR_CATEGORY__PARENT_CATEGORY:
				return getParentCategory() != null;
			case ReviewPackage.INSPECTOR_CATEGORY__EXTERNAL_PARENT:
				return externalParent != null;
			case ReviewPackage.INSPECTOR_CATEGORY__GOVERNED_BY:
				return governedBy != null && !governedBy.isEmpty();
			case ReviewPackage.INSPECTOR_CATEGORY__INSPECTORS:
				return inspectors != null && !inspectors.isEmpty();
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (uid: ");
		result.append(uid);
		result.append(", name: ");
		result.append(name);
		result.append(", description: ");
		result.append(description);
		result.append(", references: ");
		result.append(references);
		result.append(", homePage: ");
		result.append(homePage);
		result.append(')');
		return result.toString();
	}

} //InspectorCategoryImpl
