/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package com.hammurapi.review.impl;

import com.hammurapi.party.Identity;

import com.hammurapi.party.PartyPackage;
import com.hammurapi.party.Role;
import com.hammurapi.review.Governor;
import com.hammurapi.review.InspectorCategory;
import com.hammurapi.review.ReviewPackage;
import com.hammurapi.review.Tool;
import com.hammurapi.review.ToolVersion;

import java.util.Collection;
import java.util.concurrent.atomic.AtomicInteger;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.EObjectImpl;
import org.eclipse.emf.ecore.util.EDataTypeUniqueEList;
import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.EObjectContainmentWithInverseEList;
import org.eclipse.emf.ecore.util.EObjectWithInverseResolvingEList;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.util.InternalEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Tool Version</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link com.hammurapi.review.impl.ToolVersionImpl#getRoles <em>Roles</em>}</li>
 *   <li>{@link com.hammurapi.review.impl.ToolVersionImpl#getUid <em>Uid</em>}</li>
 *   <li>{@link com.hammurapi.review.impl.ToolVersionImpl#getName <em>Name</em>}</li>
 *   <li>{@link com.hammurapi.review.impl.ToolVersionImpl#getDescription <em>Description</em>}</li>
 *   <li>{@link com.hammurapi.review.impl.ToolVersionImpl#getReferences <em>References</em>}</li>
 *   <li>{@link com.hammurapi.review.impl.ToolVersionImpl#getHomePage <em>Home Page</em>}</li>
 *   <li>{@link com.hammurapi.review.impl.ToolVersionImpl#getIdentity <em>Identity</em>}</li>
 *   <li>{@link com.hammurapi.review.impl.ToolVersionImpl#getGoverns <em>Governs</em>}</li>
 *   <li>{@link com.hammurapi.review.impl.ToolVersionImpl#getEnforces <em>Enforces</em>}</li>
 *   <li>{@link com.hammurapi.review.impl.ToolVersionImpl#getTool <em>Tool</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class ToolVersionImpl extends EObjectImpl implements ToolVersion {
	/**
	 * The cached value of the '{@link #getRoles() <em>Roles</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getRoles()
	 * @generated
	 * @ordered
	 */
	protected EList<Role> roles;

	/**
	 * The default value of the '{@link #getUid() <em>Uid</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getUid()
	 * @generated
	 * @ordered
	 */
	protected static final String UID_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getUid() <em>Uid</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getUid()
	 * @generated
	 * @ordered
	 */
	protected String uid = UID_EDEFAULT;

	/**
	 * The default value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected static final String NAME_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected String name = NAME_EDEFAULT;

	/**
	 * The default value of the '{@link #getDescription() <em>Description</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDescription()
	 * @generated
	 * @ordered
	 */
	protected static final String DESCRIPTION_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getDescription() <em>Description</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDescription()
	 * @generated
	 * @ordered
	 */
	protected String description = DESCRIPTION_EDEFAULT;

	/**
	 * The cached value of the '{@link #getReferences() <em>References</em>}' attribute list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getReferences()
	 * @generated
	 * @ordered
	 */
	protected EList<String> references;

	/**
	 * The default value of the '{@link #getHomePage() <em>Home Page</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getHomePage()
	 * @generated
	 * @ordered
	 */
	protected static final String HOME_PAGE_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getHomePage() <em>Home Page</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getHomePage()
	 * @generated
	 * @ordered
	 */
	protected String homePage = HOME_PAGE_EDEFAULT;

	/**
	 * The cached value of the '{@link #getIdentity() <em>Identity</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getIdentity()
	 * @generated
	 * @ordered
	 */
	protected EList<Identity> identity;

	/**
	 * The cached value of the '{@link #getGoverns() <em>Governs</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getGoverns()
	 * @generated
	 * @ordered
	 */
	protected EList<InspectorCategory> governs;

	/**
	 * The cached value of the '{@link #getEnforces() <em>Enforces</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getEnforces()
	 * @generated
	 * @ordered
	 */
	protected EList<Governor> enforces;

	private static AtomicInteger counter = new AtomicInteger();
	
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	protected ToolVersionImpl() {
		super();
		if (getUid()==null) {
			setUid("VERSION-"+Integer.toString(counter.incrementAndGet(), Character.MAX_RADIX)+"-"+Long.toString(System.currentTimeMillis(), Character.MAX_RADIX));
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return ReviewPackage.Literals.TOOL_VERSION;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Role> getRoles() {
		if (roles == null) {
			roles = new EObjectContainmentWithInverseEList<Role>(Role.class, this, ReviewPackage.TOOL_VERSION__ROLES, PartyPackage.ROLE__OWNER);
		}
		return roles;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getUid() {
		return uid;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setUid(String newUid) {
		String oldUid = uid;
		uid = newUid;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ReviewPackage.TOOL_VERSION__UID, oldUid, uid));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getName() {
		return name;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setName(String newName) {
		String oldName = name;
		name = newName;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ReviewPackage.TOOL_VERSION__NAME, oldName, name));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getDescription() {
		return description;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setDescription(String newDescription) {
		String oldDescription = description;
		description = newDescription;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ReviewPackage.TOOL_VERSION__DESCRIPTION, oldDescription, description));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<String> getReferences() {
		if (references == null) {
			references = new EDataTypeUniqueEList<String>(String.class, this, ReviewPackage.TOOL_VERSION__REFERENCES);
		}
		return references;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getHomePage() {
		return homePage;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setHomePage(String newHomePage) {
		String oldHomePage = homePage;
		homePage = newHomePage;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ReviewPackage.TOOL_VERSION__HOME_PAGE, oldHomePage, homePage));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Identity> getIdentity() {
		if (identity == null) {
			identity = new EObjectContainmentEList<Identity>(Identity.class, this, ReviewPackage.TOOL_VERSION__IDENTITY);
		}
		return identity;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<InspectorCategory> getGoverns() {
		if (governs == null) {
			governs = new EObjectWithInverseResolvingEList.ManyInverse<InspectorCategory>(InspectorCategory.class, this, ReviewPackage.TOOL_VERSION__GOVERNS, ReviewPackage.INSPECTOR_CATEGORY__GOVERNED_BY);
		}
		return governs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Governor> getEnforces() {
		if (enforces == null) {
			enforces = new EObjectWithInverseResolvingEList.ManyInverse<Governor>(Governor.class, this, ReviewPackage.TOOL_VERSION__ENFORCES, ReviewPackage.GOVERNOR__ENFORCED_BY);
		}
		return enforces;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Tool getTool() {
		if (eContainerFeatureID() != ReviewPackage.TOOL_VERSION__TOOL) return null;
		return (Tool)eContainer();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetTool(Tool newTool, NotificationChain msgs) {
		msgs = eBasicSetContainer((InternalEObject)newTool, ReviewPackage.TOOL_VERSION__TOOL, msgs);
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setTool(Tool newTool) {
		if (newTool != eInternalContainer() || (eContainerFeatureID() != ReviewPackage.TOOL_VERSION__TOOL && newTool != null)) {
			if (EcoreUtil.isAncestor(this, newTool))
				throw new IllegalArgumentException("Recursive containment not allowed for " + toString());
			NotificationChain msgs = null;
			if (eInternalContainer() != null)
				msgs = eBasicRemoveFromContainer(msgs);
			if (newTool != null)
				msgs = ((InternalEObject)newTool).eInverseAdd(this, ReviewPackage.TOOL__VERSIONS, Tool.class, msgs);
			msgs = basicSetTool(newTool, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ReviewPackage.TOOL_VERSION__TOOL, newTool, newTool));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case ReviewPackage.TOOL_VERSION__ROLES:
				return ((InternalEList<InternalEObject>)(InternalEList<?>)getRoles()).basicAdd(otherEnd, msgs);
			case ReviewPackage.TOOL_VERSION__GOVERNS:
				return ((InternalEList<InternalEObject>)(InternalEList<?>)getGoverns()).basicAdd(otherEnd, msgs);
			case ReviewPackage.TOOL_VERSION__ENFORCES:
				return ((InternalEList<InternalEObject>)(InternalEList<?>)getEnforces()).basicAdd(otherEnd, msgs);
			case ReviewPackage.TOOL_VERSION__TOOL:
				if (eInternalContainer() != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return basicSetTool((Tool)otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case ReviewPackage.TOOL_VERSION__ROLES:
				return ((InternalEList<?>)getRoles()).basicRemove(otherEnd, msgs);
			case ReviewPackage.TOOL_VERSION__IDENTITY:
				return ((InternalEList<?>)getIdentity()).basicRemove(otherEnd, msgs);
			case ReviewPackage.TOOL_VERSION__GOVERNS:
				return ((InternalEList<?>)getGoverns()).basicRemove(otherEnd, msgs);
			case ReviewPackage.TOOL_VERSION__ENFORCES:
				return ((InternalEList<?>)getEnforces()).basicRemove(otherEnd, msgs);
			case ReviewPackage.TOOL_VERSION__TOOL:
				return basicSetTool(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eBasicRemoveFromContainerFeature(NotificationChain msgs) {
		switch (eContainerFeatureID()) {
			case ReviewPackage.TOOL_VERSION__TOOL:
				return eInternalContainer().eInverseRemove(this, ReviewPackage.TOOL__VERSIONS, Tool.class, msgs);
		}
		return super.eBasicRemoveFromContainerFeature(msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case ReviewPackage.TOOL_VERSION__ROLES:
				return getRoles();
			case ReviewPackage.TOOL_VERSION__UID:
				return getUid();
			case ReviewPackage.TOOL_VERSION__NAME:
				return getName();
			case ReviewPackage.TOOL_VERSION__DESCRIPTION:
				return getDescription();
			case ReviewPackage.TOOL_VERSION__REFERENCES:
				return getReferences();
			case ReviewPackage.TOOL_VERSION__HOME_PAGE:
				return getHomePage();
			case ReviewPackage.TOOL_VERSION__IDENTITY:
				return getIdentity();
			case ReviewPackage.TOOL_VERSION__GOVERNS:
				return getGoverns();
			case ReviewPackage.TOOL_VERSION__ENFORCES:
				return getEnforces();
			case ReviewPackage.TOOL_VERSION__TOOL:
				return getTool();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case ReviewPackage.TOOL_VERSION__ROLES:
				getRoles().clear();
				getRoles().addAll((Collection<? extends Role>)newValue);
				return;
			case ReviewPackage.TOOL_VERSION__UID:
				setUid((String)newValue);
				return;
			case ReviewPackage.TOOL_VERSION__NAME:
				setName((String)newValue);
				return;
			case ReviewPackage.TOOL_VERSION__DESCRIPTION:
				setDescription((String)newValue);
				return;
			case ReviewPackage.TOOL_VERSION__REFERENCES:
				getReferences().clear();
				getReferences().addAll((Collection<? extends String>)newValue);
				return;
			case ReviewPackage.TOOL_VERSION__HOME_PAGE:
				setHomePage((String)newValue);
				return;
			case ReviewPackage.TOOL_VERSION__IDENTITY:
				getIdentity().clear();
				getIdentity().addAll((Collection<? extends Identity>)newValue);
				return;
			case ReviewPackage.TOOL_VERSION__GOVERNS:
				getGoverns().clear();
				getGoverns().addAll((Collection<? extends InspectorCategory>)newValue);
				return;
			case ReviewPackage.TOOL_VERSION__ENFORCES:
				getEnforces().clear();
				getEnforces().addAll((Collection<? extends Governor>)newValue);
				return;
			case ReviewPackage.TOOL_VERSION__TOOL:
				setTool((Tool)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case ReviewPackage.TOOL_VERSION__ROLES:
				getRoles().clear();
				return;
			case ReviewPackage.TOOL_VERSION__UID:
				setUid(UID_EDEFAULT);
				return;
			case ReviewPackage.TOOL_VERSION__NAME:
				setName(NAME_EDEFAULT);
				return;
			case ReviewPackage.TOOL_VERSION__DESCRIPTION:
				setDescription(DESCRIPTION_EDEFAULT);
				return;
			case ReviewPackage.TOOL_VERSION__REFERENCES:
				getReferences().clear();
				return;
			case ReviewPackage.TOOL_VERSION__HOME_PAGE:
				setHomePage(HOME_PAGE_EDEFAULT);
				return;
			case ReviewPackage.TOOL_VERSION__IDENTITY:
				getIdentity().clear();
				return;
			case ReviewPackage.TOOL_VERSION__GOVERNS:
				getGoverns().clear();
				return;
			case ReviewPackage.TOOL_VERSION__ENFORCES:
				getEnforces().clear();
				return;
			case ReviewPackage.TOOL_VERSION__TOOL:
				setTool((Tool)null);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case ReviewPackage.TOOL_VERSION__ROLES:
				return roles != null && !roles.isEmpty();
			case ReviewPackage.TOOL_VERSION__UID:
				return UID_EDEFAULT == null ? uid != null : !UID_EDEFAULT.equals(uid);
			case ReviewPackage.TOOL_VERSION__NAME:
				return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
			case ReviewPackage.TOOL_VERSION__DESCRIPTION:
				return DESCRIPTION_EDEFAULT == null ? description != null : !DESCRIPTION_EDEFAULT.equals(description);
			case ReviewPackage.TOOL_VERSION__REFERENCES:
				return references != null && !references.isEmpty();
			case ReviewPackage.TOOL_VERSION__HOME_PAGE:
				return HOME_PAGE_EDEFAULT == null ? homePage != null : !HOME_PAGE_EDEFAULT.equals(homePage);
			case ReviewPackage.TOOL_VERSION__IDENTITY:
				return identity != null && !identity.isEmpty();
			case ReviewPackage.TOOL_VERSION__GOVERNS:
				return governs != null && !governs.isEmpty();
			case ReviewPackage.TOOL_VERSION__ENFORCES:
				return enforces != null && !enforces.isEmpty();
			case ReviewPackage.TOOL_VERSION__TOOL:
				return getTool() != null;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (uid: ");
		result.append(uid);
		result.append(", name: ");
		result.append(name);
		result.append(", description: ");
		result.append(description);
		result.append(", references: ");
		result.append(references);
		result.append(", homePage: ");
		result.append(homePage);
		result.append(')');
		return result.toString();
	}

} //ToolVersionImpl
