/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package com.hammurapi.review.impl;

import com.hammurapi.config.Named;
import com.hammurapi.config.Factory;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentWithInverseEList;
import org.eclipse.emf.ecore.util.EObjectResolvingEList;
import org.eclipse.emf.ecore.util.EObjectWithInverseResolvingEList;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.util.InternalEList;
import com.hammurapi.config.impl.NamedObjectDefinitionImpl;
import com.hammurapi.review.Inspector;
import com.hammurapi.review.InspectorCategory;
import com.hammurapi.review.InspectorRelationship;
import com.hammurapi.review.InspectorSet;
import com.hammurapi.review.ReviewPackage;
import com.hammurapi.review.ToolVersion;
import java.util.Collection;
import java.util.concurrent.atomic.AtomicInteger;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Inspector</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link com.hammurapi.review.impl.InspectorImpl#getLanguageModules <em>Language Modules</em>}</li>
 *   <li>{@link com.hammurapi.review.impl.InspectorImpl#getEnforcedBy <em>Enforced By</em>}</li>
 *   <li>{@link com.hammurapi.review.impl.InspectorImpl#getCategory <em>Category</em>}</li>
 *   <li>{@link com.hammurapi.review.impl.InspectorImpl#getUid <em>Uid</em>}</li>
 *   <li>{@link com.hammurapi.review.impl.InspectorImpl#getSeverity <em>Severity</em>}</li>
 *   <li>{@link com.hammurapi.review.impl.InspectorImpl#getMessageTemplate <em>Message Template</em>}</li>
 *   <li>{@link com.hammurapi.review.impl.InspectorImpl#getInspectorSet <em>Inspector Set</em>}</li>
 *   <li>{@link com.hammurapi.review.impl.InspectorImpl#getOutboundRelationships <em>Outbound Relationships</em>}</li>
 *   <li>{@link com.hammurapi.review.impl.InspectorImpl#getInboundRelationships <em>Inbound Relationships</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class InspectorImpl extends NamedObjectDefinitionImpl implements Inspector {
	/**
	 * The cached value of the '{@link #getLanguageModules() <em>Language Modules</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getLanguageModules()
	 * @generated
	 * @ordered
	 */
	protected EList<Named> languageModules;

	/**
	 * The cached value of the '{@link #getEnforcedBy() <em>Enforced By</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getEnforcedBy()
	 * @generated
	 * @ordered
	 */
	protected EList<ToolVersion> enforcedBy;

	/**
	 * The cached value of the '{@link #getCategory() <em>Category</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getCategory()
	 * @generated
	 * @ordered
	 */
	protected InspectorCategory category;

	/**
	 * The default value of the '{@link #getUid() <em>Uid</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getUid()
	 * @generated
	 * @ordered
	 */
	protected static final String UID_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getUid() <em>Uid</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getUid()
	 * @generated
	 * @ordered
	 */
	protected String uid = UID_EDEFAULT;

	/**
	 * The default value of the '{@link #getSeverity() <em>Severity</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getSeverity()
	 * @generated
	 * @ordered
	 */
	protected static final Integer SEVERITY_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getSeverity() <em>Severity</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getSeverity()
	 * @generated
	 * @ordered
	 */
	protected Integer severity = SEVERITY_EDEFAULT;

	/**
	 * The default value of the '{@link #getMessageTemplate() <em>Message Template</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMessageTemplate()
	 * @generated
	 * @ordered
	 */
	protected static final String MESSAGE_TEMPLATE_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getMessageTemplate() <em>Message Template</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMessageTemplate()
	 * @generated
	 * @ordered
	 */
	protected String messageTemplate = MESSAGE_TEMPLATE_EDEFAULT;

	/**
	 * The cached value of the '{@link #getOutboundRelationships() <em>Outbound Relationships</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getOutboundRelationships()
	 * @generated
	 * @ordered
	 */
	protected EList<InspectorRelationship> outboundRelationships;

	/**
	 * The cached value of the '{@link #getInboundRelationships() <em>Inbound Relationships</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getInboundRelationships()
	 * @generated
	 * @ordered
	 */
	protected EList<InspectorRelationship> inboundRelationships;

	private static AtomicInteger counter = new AtomicInteger();

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	protected InspectorImpl() {
		super();
		if (getUid()==null) {
			setUid("INSPECTOR-"+Integer.toString(counter.incrementAndGet(), Character.MAX_RADIX)+"-"+Long.toString(System.currentTimeMillis(), Character.MAX_RADIX));
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return ReviewPackage.Literals.INSPECTOR;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Named> getLanguageModules() {
		if (languageModules == null) {
			languageModules = new EObjectResolvingEList<Named>(Named.class, this, ReviewPackage.INSPECTOR__LANGUAGE_MODULES);
		}
		return languageModules;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<ToolVersion> getEnforcedBy() {
		if (enforcedBy == null) {
			enforcedBy = new EObjectWithInverseResolvingEList.ManyInverse<ToolVersion>(ToolVersion.class, this, ReviewPackage.INSPECTOR__ENFORCED_BY, ReviewPackage.TOOL_VERSION__ENFORCES);
		}
		return enforcedBy;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public InspectorCategory getCategory() {
		if (category != null && category.eIsProxy()) {
			InternalEObject oldCategory = (InternalEObject)category;
			category = (InspectorCategory)eResolveProxy(oldCategory);
			if (category != oldCategory) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, ReviewPackage.INSPECTOR__CATEGORY, oldCategory, category));
			}
		}
		return category;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public InspectorCategory basicGetCategory() {
		return category;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetCategory(InspectorCategory newCategory, NotificationChain msgs) {
		InspectorCategory oldCategory = category;
		category = newCategory;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, ReviewPackage.INSPECTOR__CATEGORY, oldCategory, newCategory);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setCategory(InspectorCategory newCategory) {
		if (newCategory != category) {
			NotificationChain msgs = null;
			if (category != null)
				msgs = ((InternalEObject)category).eInverseRemove(this, ReviewPackage.INSPECTOR_CATEGORY__INSPECTORS, InspectorCategory.class, msgs);
			if (newCategory != null)
				msgs = ((InternalEObject)newCategory).eInverseAdd(this, ReviewPackage.INSPECTOR_CATEGORY__INSPECTORS, InspectorCategory.class, msgs);
			msgs = basicSetCategory(newCategory, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ReviewPackage.INSPECTOR__CATEGORY, newCategory, newCategory));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getUid() {
		return uid;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setUid(String newUid) {
		String oldUid = uid;
		uid = newUid;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ReviewPackage.INSPECTOR__UID, oldUid, uid));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Integer getSeverity() {
		return severity;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setSeverity(Integer newSeverity) {
		Integer oldSeverity = severity;
		severity = newSeverity;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ReviewPackage.INSPECTOR__SEVERITY, oldSeverity, severity));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getMessageTemplate() {
		return messageTemplate;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setMessageTemplate(String newMessageTemplate) {
		String oldMessageTemplate = messageTemplate;
		messageTemplate = newMessageTemplate;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ReviewPackage.INSPECTOR__MESSAGE_TEMPLATE, oldMessageTemplate, messageTemplate));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public InspectorSet getInspectorSet() {
		if (eContainerFeatureID() != ReviewPackage.INSPECTOR__INSPECTOR_SET) return null;
		return (InspectorSet)eContainer();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetInspectorSet(InspectorSet newInspectorSet, NotificationChain msgs) {
		msgs = eBasicSetContainer((InternalEObject)newInspectorSet, ReviewPackage.INSPECTOR__INSPECTOR_SET, msgs);
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setInspectorSet(InspectorSet newInspectorSet) {
		if (newInspectorSet != eInternalContainer() || (eContainerFeatureID() != ReviewPackage.INSPECTOR__INSPECTOR_SET && newInspectorSet != null)) {
			if (EcoreUtil.isAncestor(this, newInspectorSet))
				throw new IllegalArgumentException("Recursive containment not allowed for " + toString());
			NotificationChain msgs = null;
			if (eInternalContainer() != null)
				msgs = eBasicRemoveFromContainer(msgs);
			if (newInspectorSet != null)
				msgs = ((InternalEObject)newInspectorSet).eInverseAdd(this, ReviewPackage.INSPECTOR_SET__INSPECTORS, InspectorSet.class, msgs);
			msgs = basicSetInspectorSet(newInspectorSet, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ReviewPackage.INSPECTOR__INSPECTOR_SET, newInspectorSet, newInspectorSet));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<InspectorRelationship> getOutboundRelationships() {
		if (outboundRelationships == null) {
			outboundRelationships = new EObjectContainmentWithInverseEList<InspectorRelationship>(InspectorRelationship.class, this, ReviewPackage.INSPECTOR__OUTBOUND_RELATIONSHIPS, ReviewPackage.INSPECTOR_RELATIONSHIP__SOURCE);
		}
		return outboundRelationships;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<InspectorRelationship> getInboundRelationships() {
		if (inboundRelationships == null) {
			inboundRelationships = new EObjectWithInverseResolvingEList<InspectorRelationship>(InspectorRelationship.class, this, ReviewPackage.INSPECTOR__INBOUND_RELATIONSHIPS, ReviewPackage.INSPECTOR_RELATIONSHIP__TARGET);
		}
		return inboundRelationships;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case ReviewPackage.INSPECTOR__ENFORCED_BY:
				return ((InternalEList<InternalEObject>)(InternalEList<?>)getEnforcedBy()).basicAdd(otherEnd, msgs);
			case ReviewPackage.INSPECTOR__CATEGORY:
				if (category != null)
					msgs = ((InternalEObject)category).eInverseRemove(this, ReviewPackage.INSPECTOR_CATEGORY__INSPECTORS, InspectorCategory.class, msgs);
				return basicSetCategory((InspectorCategory)otherEnd, msgs);
			case ReviewPackage.INSPECTOR__INSPECTOR_SET:
				if (eInternalContainer() != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return basicSetInspectorSet((InspectorSet)otherEnd, msgs);
			case ReviewPackage.INSPECTOR__OUTBOUND_RELATIONSHIPS:
				return ((InternalEList<InternalEObject>)(InternalEList<?>)getOutboundRelationships()).basicAdd(otherEnd, msgs);
			case ReviewPackage.INSPECTOR__INBOUND_RELATIONSHIPS:
				return ((InternalEList<InternalEObject>)(InternalEList<?>)getInboundRelationships()).basicAdd(otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case ReviewPackage.INSPECTOR__ENFORCED_BY:
				return ((InternalEList<?>)getEnforcedBy()).basicRemove(otherEnd, msgs);
			case ReviewPackage.INSPECTOR__CATEGORY:
				return basicSetCategory(null, msgs);
			case ReviewPackage.INSPECTOR__INSPECTOR_SET:
				return basicSetInspectorSet(null, msgs);
			case ReviewPackage.INSPECTOR__OUTBOUND_RELATIONSHIPS:
				return ((InternalEList<?>)getOutboundRelationships()).basicRemove(otherEnd, msgs);
			case ReviewPackage.INSPECTOR__INBOUND_RELATIONSHIPS:
				return ((InternalEList<?>)getInboundRelationships()).basicRemove(otherEnd, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eBasicRemoveFromContainerFeature(NotificationChain msgs) {
		switch (eContainerFeatureID()) {
			case ReviewPackage.INSPECTOR__INSPECTOR_SET:
				return eInternalContainer().eInverseRemove(this, ReviewPackage.INSPECTOR_SET__INSPECTORS, InspectorSet.class, msgs);
		}
		return super.eBasicRemoveFromContainerFeature(msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case ReviewPackage.INSPECTOR__LANGUAGE_MODULES:
				return getLanguageModules();
			case ReviewPackage.INSPECTOR__ENFORCED_BY:
				return getEnforcedBy();
			case ReviewPackage.INSPECTOR__CATEGORY:
				if (resolve) return getCategory();
				return basicGetCategory();
			case ReviewPackage.INSPECTOR__UID:
				return getUid();
			case ReviewPackage.INSPECTOR__SEVERITY:
				return getSeverity();
			case ReviewPackage.INSPECTOR__MESSAGE_TEMPLATE:
				return getMessageTemplate();
			case ReviewPackage.INSPECTOR__INSPECTOR_SET:
				return getInspectorSet();
			case ReviewPackage.INSPECTOR__OUTBOUND_RELATIONSHIPS:
				return getOutboundRelationships();
			case ReviewPackage.INSPECTOR__INBOUND_RELATIONSHIPS:
				return getInboundRelationships();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case ReviewPackage.INSPECTOR__LANGUAGE_MODULES:
				getLanguageModules().clear();
				getLanguageModules().addAll((Collection<? extends Named>)newValue);
				return;
			case ReviewPackage.INSPECTOR__ENFORCED_BY:
				getEnforcedBy().clear();
				getEnforcedBy().addAll((Collection<? extends ToolVersion>)newValue);
				return;
			case ReviewPackage.INSPECTOR__CATEGORY:
				setCategory((InspectorCategory)newValue);
				return;
			case ReviewPackage.INSPECTOR__UID:
				setUid((String)newValue);
				return;
			case ReviewPackage.INSPECTOR__SEVERITY:
				setSeverity((Integer)newValue);
				return;
			case ReviewPackage.INSPECTOR__MESSAGE_TEMPLATE:
				setMessageTemplate((String)newValue);
				return;
			case ReviewPackage.INSPECTOR__INSPECTOR_SET:
				setInspectorSet((InspectorSet)newValue);
				return;
			case ReviewPackage.INSPECTOR__OUTBOUND_RELATIONSHIPS:
				getOutboundRelationships().clear();
				getOutboundRelationships().addAll((Collection<? extends InspectorRelationship>)newValue);
				return;
			case ReviewPackage.INSPECTOR__INBOUND_RELATIONSHIPS:
				getInboundRelationships().clear();
				getInboundRelationships().addAll((Collection<? extends InspectorRelationship>)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case ReviewPackage.INSPECTOR__LANGUAGE_MODULES:
				getLanguageModules().clear();
				return;
			case ReviewPackage.INSPECTOR__ENFORCED_BY:
				getEnforcedBy().clear();
				return;
			case ReviewPackage.INSPECTOR__CATEGORY:
				setCategory((InspectorCategory)null);
				return;
			case ReviewPackage.INSPECTOR__UID:
				setUid(UID_EDEFAULT);
				return;
			case ReviewPackage.INSPECTOR__SEVERITY:
				setSeverity(SEVERITY_EDEFAULT);
				return;
			case ReviewPackage.INSPECTOR__MESSAGE_TEMPLATE:
				setMessageTemplate(MESSAGE_TEMPLATE_EDEFAULT);
				return;
			case ReviewPackage.INSPECTOR__INSPECTOR_SET:
				setInspectorSet((InspectorSet)null);
				return;
			case ReviewPackage.INSPECTOR__OUTBOUND_RELATIONSHIPS:
				getOutboundRelationships().clear();
				return;
			case ReviewPackage.INSPECTOR__INBOUND_RELATIONSHIPS:
				getInboundRelationships().clear();
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case ReviewPackage.INSPECTOR__LANGUAGE_MODULES:
				return languageModules != null && !languageModules.isEmpty();
			case ReviewPackage.INSPECTOR__ENFORCED_BY:
				return enforcedBy != null && !enforcedBy.isEmpty();
			case ReviewPackage.INSPECTOR__CATEGORY:
				return category != null;
			case ReviewPackage.INSPECTOR__UID:
				return UID_EDEFAULT == null ? uid != null : !UID_EDEFAULT.equals(uid);
			case ReviewPackage.INSPECTOR__SEVERITY:
				return SEVERITY_EDEFAULT == null ? severity != null : !SEVERITY_EDEFAULT.equals(severity);
			case ReviewPackage.INSPECTOR__MESSAGE_TEMPLATE:
				return MESSAGE_TEMPLATE_EDEFAULT == null ? messageTemplate != null : !MESSAGE_TEMPLATE_EDEFAULT.equals(messageTemplate);
			case ReviewPackage.INSPECTOR__INSPECTOR_SET:
				return getInspectorSet() != null;
			case ReviewPackage.INSPECTOR__OUTBOUND_RELATIONSHIPS:
				return outboundRelationships != null && !outboundRelationships.isEmpty();
			case ReviewPackage.INSPECTOR__INBOUND_RELATIONSHIPS:
				return inboundRelationships != null && !inboundRelationships.isEmpty();
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (uid: ");
		result.append(uid);
		result.append(", severity: ");
		result.append(severity);
		result.append(", messageTemplate: ");
		result.append(messageTemplate);
		result.append(')');
		return result.toString();
	}

} //InspectorImpl
